﻿<?php
if (defined('PS_ADMIN_DIR'))
	include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');
else
{
	if (!defined('_PS_ADMIN_DIR_'))
		define('_PS_ADMIN_DIR_', getcwd());
	include_once(_PS_ADMIN_DIR_.'/../classes/AdminTab.php');
}
require_once(_PS_MODULE_DIR_.'pss_timemsgpro/pss_timemsgpro.php');
require_once(_PS_MODULE_DIR_.'pss_timemsgpro/classes/PssTimeMsgProUtils.php');
require_once(_PS_MODULE_DIR_.'pss_timemsgpro/classes/PssTimeMsgPro.php');

class adminpss_timemsgpro extends AdminTab
{ 
	// absolute URL to this module
	private $absoluteUrl;
	// absolute path (in OS sense) to this module
	private $absolutePath;
	// relative URL to this module
	private $relativeUrl;
	// relative path (in OS sense) to this module
	private $relativePath;
	
	// the version of module files in directory
	private $_directoryVersion;
	// the version history
	private $_versionHistory = array('0.1', '0.2', '0.3', '0.4', '0.5', '0.6', '1.0', '1.1', '1.2', '1.3', '1.4', '1.5');

	public function __construct()
    {
		global $cookie;

 	 	$this->table = 'prestascope_timemsgpro';
	 	$this->className = 'PssTimeMsgPro';
	 	$this->identifier = 'id_msg';
		$this->lang = true;
	 	$this->edit = true;
	 	$this->noAdd = false;
	 	$this->view = false;
	 	$this->delete = true;
	
		$translations = array(
			'displayed' => $this->l('displayed'),
			'not displayed' => $this->l('not displayed'),
			'action' => $this->l('action'),
			'text' => $this->l('text'),
			'user is logged' => $this->l('user is logged'),
			'user is not logged' => $this->l('user is not logged'),
			'user in group' => $this->l('user in group '),
			'category' => $this->l('category '),
			'product' => $this->l('product '),
			);
	
		// SELECT tl.name FROM ps_category t inner join ps_category_lang tl on t.id_category=tl.id_category WHERE t.id_category=1 AND tl.id_lang=2
		// SELECT tl.name FROM ps_group t inner join ps_group_lang tl on t.id_group=tl.id_group WHERE t.id_group=1 AND tl.id_lang=2
		// add a field to know if the message is displayed or not
//		$this->_select = "CASE a.`active`=1 AND IFNULL(a.`from_date`, '2000-01-01') <= CURRENT_DATE() AND IFNULL(a.`to_date`, '3000-01-01') >= CURRENT_DATE() WHEN TRUE THEN 1 ELSE 0 END AS `displayed`";
//			CASE a.`is_logged`=1 WHEN TRUE THEN concat('user is logged', '<br />') ELSE '' END,
		$this->_select = "
			CASE a.`active`=1 AND IFNULL(a.`from_date`, '2000-01-01') <= CURRENT_DATE() AND IFNULL(a.`to_date`, '3000-01-01') >= CURRENT_DATE() WHEN TRUE THEN '".$translations['displayed']."' ELSE '".$translations['not displayed']."' END AS `displayed`
			";
		
/*		$this->_join = 'LEFT JOIN '._DB_PREFIX_.'customer c on (c.id_customer = a.id_customer)
		LEFT JOIN '._DB_PREFIX_.'currency cu on (cu.id_currency = a.id_currency)
		LEFT JOIN '._DB_PREFIX_.'carrier ca on (ca.id_carrier = a.id_carrier)
		';*/
		
		$this->fieldsDisplay = array(
			'id_msg' => array('title' => $this->l('ID'), 'align' => 'center', 'width' => 25),
			'name' => array('title' => $this->l('Name'), 'width' => 130),
			'hook_name' => array('title' => $this->l('Hook'), 'width' => 75),
			'from_date' => array('title' => $this->l('From'), 'width' => 30, 'type' => 'date', 'align' => 'right'),
			'to_date' => array('title' => $this->l('To'), 'width' => 30, 'type' => 'date', 'align' => 'right'),
			'active' => array('title' => $this->l('Enabled'), 'width' => 25, 'align' => 'center', 'active' => 'status', 'type' => 'bool', 'orderby' => false),
//			'displayed' => array('title' => $this->l('Displayed'), 'width' => 25, 'align' => 'center', 'icon' => array('displayed' => 'enabled.gif', 'not displayed' => 'disabled.gif'), 'type' => 'bool', 'orderby' => false),
			'displayed' => array('title' => $this->l('Displayed'), 'width' => 25, 'align' => 'center', 'icon' => array($this->l('displayed') => 'enabled.gif', $this->l('not displayed') => 'disabled.gif'), 'type' => 'bool', 'orderby' => false),
			);

		// full url & path to this module
		$moduleFolder = 'pss_timemsgpro';
		$this->absoluteUrl = $this->is_https()?'https':'http'.'://'.$_SERVER['HTTP_HOST'].':'.$_SERVER['SERVER_PORT']. _MODULE_DIR_ . $moduleFolder . '/';
		$this->absolutePath = _PS_ROOT_DIR_.DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.$moduleFolder.DIRECTORY_SEPARATOR;
		// relative url & path to this module
        $this->relativeUrl = _MODULE_DIR_.$moduleFolder.'/';
        $this->relativePath = _PS_MODULE_DIR_.$moduleFolder.'/';

		// load your classes
//		require_once($this->absolutePath.'classes/PssTimeMsgProUtils.php');
//		require_once($this->absolutePath.'classes/PssTimeMsgPro.php');

		// import lang file (except for 1.4.1 and later versions)
		if (PssTimeMsgProUtils::checkPsVersion('1.4.0') || !PssTimeMsgProUtils::isPs14x())
			$this->_importLang();
			
		// get the version of module files in directory
		$this->_directoryVersion = pss_timemsgpro::$_config['PRESTASCOPE_TIMEMSG_VERSION'];

		parent::__construct();

		// load tab access for current user profile profile
		$this->tabAccess = Profile::getProfileAccess($cookie->profile, $this->id);
	}
	private function _importLang() 
	{
		global $cookie, $_LANGADM, $_MODULE;
		$langFile = $this->relativePath . Language::getIsoById(intval($cookie->id_lang)) . '.php';
		if (file_exists($langFile)) 
		{
			require_once $langFile;
			foreach ($_MODULE as $key => $value) 
			{
//				if (substr(strip_tags($key), 0, 5) == 'Admin') 
				if (substr(strip_tags($key), 0, 5) == 'admin') 
				{
					// change 2012-06-01 : be careful not to replace the _ in the admin class name
//					$_LANGADM[str_replace('_', '', strip_tags($key))] = $value;
					$_LANGADM[PssTimeMsgProUtils::str_lreplace('_', '', strip_tags($key))] = $value;
				}
			}
		}
	}
	private function is_https()
	{
		return strtolower(substr($_SERVER["SERVER_PROTOCOL"],0,5))=='https'? true : false;
	}
  
	/* *****************************************************************************************
	 *
	 *					FUNCTIONS TO DISPLAY TAB CONTENT AND DEAL WITH ACTIONS
	 *
	 * ***************************************************************************************** */
	public function postProcess()
	{
		// init
		PssTimeMsgProUtils::manageLogSize();
		$this->_errors = array();

		// -------------------------------------------------------
		// Update module version
		//
		if (Tools::isSubmit('submitUpdateModule'))
		{
			// Get the installed version
			$installedVersion = Configuration::get('PRESTASCOPE_TIMEMSG_VERSION');
			$this->migrateVersion($installedVersion);
			// everything's ok ?
			if (empty($this->_errors))
			{
				PssTimeMsgProUtils::addLog('Update version from '.$installedVersion.' to '.$this->_directoryVersion.' successfully');
				echo '<div class="conf ok">'.$this->l('Version updated successfully').'</div>';
			}
		}

		// some specials
		if (Tools::getValue('submitAddprestascope_timemsgpro'))
		{
			// custom check for template file - mandatory
			if (PssTimeMsgProUtils::isPs15x()) 
			{
				// Validate TPL function's name has changed
				if ($_POST['template_name_text']=='NONE' || !Validate::isTplName($_POST['template_name_text']))
					$this->_errors[] = $this->l('You must choose a template to display the message');
			}
			else
			{
				if ($_POST['template_name_text']=='NONE' || !Validate::isTplFileName($_POST['template_name_text']))
					$this->_errors[] = $this->l('You must choose a template to display the message');
			}

			$_POST['user_class'] = 'NONE';
			$_POST['hook_name'] = $_POST['hook_name_text'];
			$_POST['template_name'] = $_POST['template_name_text'];
			
			// no need to parent process if there are already some errors
			if (empty($this->_errors))
				parent::postProcess();
		}
		else
		{
			parent::postProcess();
		}
	}
	public function display()
	{
		global $currentIndex, $cookie;
		$iso = Language::getIsoById(intval($cookie->id_lang));	

		// -------------------------------------------------------
		// check module version
		//
		// Get the installed version
		$installedVersion = Configuration::get('PRESTASCOPE_TIMEMSG_VERSION');
		// if the version is not up-to-date, display the update version form
		if ($installedVersion!==$this->_directoryVersion) 
		{
			// the beginning of the HTML to display
			echo $this->displayMigrationForm($installedVersion);
			return;
		}

		if (!Tools::isSubmit('updateprestascope_timemsgpro') AND 
			(!Tools::isSubmit('submitAddprestascope_timemsgpro') OR empty($this->_errors)) AND 
			!Tools::isSubmit('submitAddupdateprestascope_timemsgpro') AND 
			!Tools::isSubmit('addprestascope_timemsgpro'))
		{
			if (_PSS_TIMEMSGPRO_LICENCE_==='BASIC')
				echo '<h2>'.$this->l('Time messages').'</h2>';
			else
				echo '<h2>'.$this->l('Shop scheduler').'</h2>';
			
			// ------------------------------------------------------------------------------
			// check mandatory properties and display warning if not properly set
			//
			// Check if module is associated to all expected hooks
			PssTimeMsgPro::updateHooksForModule();
		}
		parent::display();
	}
	/**
	 * Manage page display (form, list...)
	 *
	 * COPIED FROM AdminTab.php file (PRESTASHOP 1.4.7 version).
	 * Because 1.3.7 version contains a bug : a non mandatory empty date field was returned as invalid ! Now, it checks also : AND !empty($field)
	 *
	 * @param string $className Allow to validate a different class than the current one
	 */
	public function validateRules($className = false)
	{
		if (!$className)
			$className = $this->className;

		/* Class specific validation rules */
		$rules = call_user_func(array($className, 'getValidationRules'), $className);

		if ((sizeof($rules['requiredLang']) OR sizeof($rules['sizeLang']) OR sizeof($rules['validateLang'])))
		{
			/* Language() instance determined by default language */
			$defaultLanguage = new Language((int)(Configuration::get('PS_LANG_DEFAULT')));

			/* All availables languages */
			$languages = Language::getLanguages(false);
		}

		/* Checking for required fields */
		foreach ($rules['required'] AS $field)
			if (($value = Tools::getValue($field)) == false AND (string)$value != '0')
				if (!Tools::getValue($this->identifier) OR ($field != 'passwd' AND $field != 'no-picture'))
					$this->_errors[] = $this->l('the field').' <b>'.call_user_func(array($className, 'displayFieldName'), $field, $className).'</b> '.$this->l('is required');

		/* Checking for multilingual required fields */
		foreach ($rules['requiredLang'] AS $fieldLang)
			if (($empty = Tools::getValue($fieldLang.'_'.$defaultLanguage->id)) === false OR $empty !== '0' AND empty($empty))
				$this->_errors[] = $this->l('the field').' <b>'.call_user_func(array($className, 'displayFieldName'), $fieldLang, $className).'</b> '.$this->l('is required at least in').' '.$defaultLanguage->name;

		/* Checking for maximum fields sizes */
		foreach ($rules['size'] AS $field => $maxLength)
			if (Tools::getValue($field) !== false AND Tools::strlen(Tools::getValue($field)) > $maxLength)
				$this->_errors[] = $this->l('the field').' <b>'.call_user_func(array($className, 'displayFieldName'), $field, $className).'</b> '.$this->l('is too long').' ('.$maxLength.' '.$this->l('chars max').')';

		/* Checking for maximum multilingual fields size */
		foreach ($rules['sizeLang'] AS $fieldLang => $maxLength)
			foreach ($languages AS $language)
				if (Tools::getValue($fieldLang.'_'.$language['id_lang']) !== false AND Tools::strlen(Tools::getValue($fieldLang.'_'.$language['id_lang'])) > $maxLength)
					$this->_errors[] = $this->l('the field').' <b>'.call_user_func(array($className, 'displayFieldName'), $fieldLang, $className).' ('.$language['name'].')</b> '.$this->l('is too long').' ('.$maxLength.' '.$this->l('chars max, html chars including').')';

		/* Overload this method for custom checking */
		$this->_childValidation();

		/* Checking for fields validity */
		foreach ($rules['validate'] AS $field => $function)
			if (($value = Tools::getValue($field)) !== false AND !empty($value) AND ($field != 'passwd')) 			
				if (!Validate::$function($value))
					$this->_errors[] = $this->l('the field').' <b>'.call_user_func(array($className, 'displayFieldName'), $field, $className).'</b> '.$this->l('is invalid');

		/* Checking for passwd_old validity */
		if (($value = Tools::getValue('passwd')) != false)
		{
			if ($className == 'Employee' AND !Validate::isPasswdAdmin($value))
				$this->_errors[] = $this->l('the field').' <b>'.call_user_func(array($className, 'displayFieldName'), 'passwd', $className).'</b> '.$this->l('is invalid');
			elseif ($className == 'Customer' AND !Validate::isPasswd($value))
				$this->_errors[] = $this->l('the field').' <b>'.call_user_func(array($className, 'displayFieldName'), 'passwd', $className).'</b> '.$this->l('is invalid');
		}

		/* Checking for multilingual fields validity */
		foreach ($rules['validateLang'] AS $fieldLang => $function)
			foreach ($languages AS $language)
				if (($value = Tools::getValue($fieldLang.'_'.$language['id_lang'])) !== false AND !empty($value))
					if (!Validate::$function($value))
						$this->_errors[] = $this->l('the field').' <b>'.call_user_func(array($className, 'displayFieldName'), $fieldLang, $className).' ('.$language['name'].')</b> '.$this->l('is invalid');
	}
	/**
	 * Display the list and below, the help area
	 */
	public function displayList()
	{
		parent::displayList();
		$this->displayHelpArea();
		
		// also display current licence
		echo '
			<div class="clear">&nbsp;</div>
			<div style="text-align:center; font-size:9px; font-style:italic;">'.$this->l('Module active licence').' : '.(_PSS_TIMEMSGPRO_LICENCE_==='BASIC'?$this->l('free module'):$this->l('Professional')).'</div>';
	}
	/**
	 * Display the Create / Edit form
	 */
	public function displayForm($isMainTab = true)
	{
		global $currentIndex, $cookie, $link;

		parent::displayForm();
		$iso = Language::getIsoById(intval($cookie->id_lang));		
		// for 1.2.x version, load the languages because theyr are not loaded by parent::displayForm()
		if (PssTimeMsgProUtils::isPs12x())
		{
			$allowEmployeeFormLang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
			if ($allowEmployeeFormLang && !$cookie->employee_form_lang)
				$cookie->employee_form_lang = intval(Configuration::get('PS_LANG_DEFAULT'));
			$useLangFromCookie = false;
			$languages = Language::getLanguages();
			if ($allowEmployeeFormLang)
				foreach ($this->_languages AS $lang)
					if ($cookie->employee_form_lang == $lang['id_lang'])
						$useLangFromCookie = true;
			if (!$useLangFromCookie)
				$defaultFormLanguage = intval(Configuration::get('PS_LANG_DEFAULT'));
			else
				$defaultFormLanguage = intval($cookie->employee_form_lang);
			echo '
				<script type="text/javascript">
					id_language = Number('.$defaultFormLanguage.');
				</script>';

		}
		else
		{
			$languages = $this->_languages;
			$defaultFormLanguage = $this->_defaultFormLanguage;
		}
		
		// load the object to edit
		$obj = $this->loadObject(true);
		
		// prepare multi-lang fields
//		$divLangName = 'mmsg¤href';
		$divLangName = 'mmsg';
		
		// -----------------------------------------------------------------------------------
		// Compute available hooks list as intersection between a list of hooks supported by this module and the list of available hooks in running Prestashop version
		//
		// prepare the list of visible hooks (for text display)
		$visibleHookList = $this->getVisibleHookList();
		
		// -----------------------------------------------------------------------------------
		// Build the list of available template files
		// A template could be :
		//  	> located in module / theme folder : the theme folder template has highest priority
		//		> located only in module folder
		//		> located only in theme folder (I don't want users to make changes in the module folders, only in theme one)
		//
		$basicList = $this->getTemplateList(false);
		$templateListText = array('NONE'=>$this->l('------- Choose one -------'));
		$templateListText = array_merge($templateListText, $basicList);
			
		// @change for Prestashop 1.5 compatibility
		if (PssTimeMsgProUtils::isPs15x())
		{
?>
			<link href="<?php echo _PS_JS_DIR_; ?>jquery/ui/themes/base/jquery.ui.theme.css" rel="stylesheet" type="text/css" media="all" />
			<link href="<?php echo _PS_JS_DIR_; ?>jquery/ui/themes/base/jquery.ui.datepicker.css" rel="stylesheet" type="text/css" media="all" />
			<script type="text/javascript" src="<?php echo _PS_JS_DIR_; ?>jquery/ui/jquery.ui.core.min.js"></script>
			<script type="text/javascript" src="<?php echo _PS_JS_DIR_; ?>jquery/ui/jquery.ui.datepicker.min.js"></script>
			<script type="text/javascript" src="<?php echo _PS_JS_DIR_; ?>jquery/ui/i18n/jquery.ui.datepicker-fr.js"></script>
<?php			
		}
		else
		{
?>
		<script type="text/javascript" src="<?php echo _PS_JS_DIR_; ?>jquery/datepicker/jquery-ui-personalized-1.6rc4.packed.js"></script>
		<script type="text/javascript" src="<?php echo _PS_JS_DIR_; ?>jquery/datepicker/ui/i18n/ui.datepicker-<?php echo $iso ?>.js"></script>
<?php		
		}
?>
		<script type="text/javascript"> 
			jQuery().ready(function(){
				$("#from_date").datepicker({
					startDate: "01/01/1970",
					endDate: (new Date()).toString(),
					prevText:"",
					nextText:"",
					dateFormat:"yy-mm-dd"});
				$("#to_date").datepicker({
					startDate: "01/01/1970",
					endDate: (new Date()).toString(),
					prevText:"",
					nextText:"",
					dateFormat:"yy-mm-dd"});
			});
		</script>
<?php		

		echo '
		<form id="mainForm" action="'.$currentIndex.'&submitAdd'.$this->table.'=1&token='.$this->token.'" method="post" enctype="multipart/form-data" class="width2" style="width:100%;">
		'.($obj->id ? '<input type="hidden" name="'.$this->identifier.'" value="'.$obj->id.'" />' : '').'
			<input type="hidden" name="active" value="'.($obj->active ? $this->getFieldValue($obj, 'active'): 0).'" />
			<input type="hidden" name="order" value="'.($obj->order ? $this->getFieldValue($obj, 'order'): 0).'" />
			<input type="hidden" name="duration" value="'.($obj->duration ? $this->getFieldValue($obj, 'duration'): 0).'" />
			<input type="hidden" name="cron_expression" value="'.($obj->cron_expression ? $this->getFieldValue($obj, 'cron_expression'): 'NONE').'" />
			<input type="hidden" name="other_rule" value="'.($obj->other_rule ? $this->getFieldValue($obj, 'other_rule'): 'NONE').'" />
			<input type="hidden" name="choice" value="1" />
			<input type="hidden" name="css_name" value="NONE" />
			<input type="hidden" name="exceptions" value="NONE" />
			<input type="hidden" name="user_class" value="NONE" />
			<input type="hidden" name="is_logged" value="-1" />
			<input type="hidden" name="id_group" value="0" />
			<input type="hidden" name="id_category" value="0" />
			<input type="hidden" name="id_product" value="0" />
			';
			
		// ******************************************************************************************************
		// MESSAGE GENERIC
		echo '
			<fieldset>
				<legend>
					<img src="../img/admin/nav-user.gif" />';
		if (_PSS_TIMEMSGPRO_LICENCE_==='BASIC')
			echo ($obj->id ? $this->l('Editing a message to display'):$this->l('Creating a message to display'));
		else
			echo ($obj->id ? $this->l('Editing a message to display / an action to trigger'):$this->l('Creating a message to display / an action to trigger'));
		echo '
				</legend>';
		// ----------------------------------------------------------
		// Name
		echo '
				<label>'.$this->l('Name').'&nbsp;:&nbsp;</label>
				<div class="margin-form">
					<input type="text" size="33" maxlength="255" name="name" value="'.htmlentities($this->getFieldValue($obj, 'name'), ENT_COMPAT, 'UTF-8').'" /> <sup>*</sup>
					<p>'.$this->l('Only used to find it in the list').'</p>
				</div>
				<div class="clear">&nbsp;</div>
				';
		// END OF MESSAGE GENERIC
		echo '
			</fieldset>
			<div class="clear">&nbsp;</div>';
				
		// ******************************************************************************************************
		// CREATION CHOICE
		// choose between displaying a message (default) or triggering an action
		echo '
			<fieldset><legend><img src="../img/admin/nav-user.gif" />'.$this->l('Message to display').'</legend>';

		// ----------------------------------------------------------
		// Message content
		echo '
				<label>'.$this->l('Content').' </label>
				<div class="margin-form">';
		foreach ($languages as $language)
			echo '	<div id="mmsg_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultFormLanguage ? 'block' : 'none').';float: left;">
						<textarea class="rte" cols="80" rows="30" id="msg_'.$language['id_lang'].'" name="msg_'.$language['id_lang'].'">'.htmlentities(stripslashes($this->getFieldValue($obj, 'msg', $language['id_lang'])), ENT_COMPAT, 'UTF-8').'</textarea>
					</div>';
		$this->displayFlags($languages, $defaultFormLanguage, $divLangName, 'mmsg');
		echo '	
				</div> <sup>*</sup>
				<div class="clear">&nbsp;</div>
			';

		// ----------------------------------------------------------
		// Hook list
		echo '
				<label>'.$this->l('Display in').'&nbsp;:&nbsp;</label>
				<div class="margin-form">
					<select name="hook_name_text" style="width:600px;">';
		foreach($visibleHookList as $itemValue=>$itemName)
		{
//						<option value="'.$itemValue.'"'.($this->getFieldValue($obj, 'hook_name') == $itemValue ? ' selected="selected"' : '').'>'.htmlentities($itemName, ENT_COMPAT, 'UTF-8').'</option>
			echo '
						<option value="'.$itemValue.'"'.($this->getFieldValue($obj, 'hook_name') == $itemValue ? ' selected="selected"' : '').'>'.$itemName.'</option>
			';
		}		
		echo '
					</select> <sup>*</sup>
					<p>'.$this->l('Choose the place you want to see this message displayed').'</p>
				</div>
				<div class="clear">&nbsp;</div>';
				
		// ----------------------------------------------------------
		// Templates list
		echo '
				<label>'.$this->l('Using template').'&nbsp;:&nbsp;</label>
				<div class="margin-form">
					<select name="template_name_text" style="width:600px;">';
		foreach($templateListText as $itemValue=>$itemName)
		{
			echo '
						<option value="'.$itemValue.'"'.($this->getFieldValue($obj, 'template_name') == $itemValue ? ' selected="selected"' : '').'>'.htmlentities($itemName, ENT_COMPAT, 'UTF-8').'</option>
			';
		}		
		echo '
					</select> <sup>*</sup>
					<p>'.$this->l('Choose the template file you want to use to display this message').'</p>
				</div>
				<div class="clear">&nbsp;</div>';
			
		echo '
			</fieldset>
			<div class="clear">&nbsp;</div>';
		// END OF DISPLAY A MESSAGE
				
		// ******************************************************************************************************
		// DISPLAY BASIC RULES
		echo '
			<fieldset><legend><img src="../img/admin/nav-user.gif" />'.$this->l('Scheduler rules').'</legend>';
			
		// ----------------------------------------------------------
		// Dates rules
		// @change for Prestashop 1.5 compatibility : added 'datepicker' class to set valid z-index
		echo '
				<label>'.$this->l('Display from').' </label>
				<div class="margin-form">
					<p><input type="text" size="20" id="from_date" name="from_date" class="datepicker" value="'.$this->getFieldValue($obj, 'from_date').'"></p>
					<p class="clear">'.$this->l('The date the message begins to be displayed. Let the field empty no to set any starting date.').'</p>
				</div>
				<label>'.$this->l('Display until').' </label>
				<div class="margin-form">
					<p><input type="text" size="20" id="to_date" name="to_date" class="datepicker" value="'.$this->getFieldValue($obj, 'to_date').'"></p>
					<p class="clear">'.$this->l('The date the message stops to be displayed. Let the field empty not to set any time limit.').'</p>
				</div>';
		// END OF DISPLAY BASIC RULES

		echo '
			</fieldset>
			<div class="clear">&nbsp;</div>';

		// ----------------------------------------------------------
		// Form submit
		echo '
			<div class="margin-form">
				<input type="submit" value="'.$this->l('   Save   ').'" name="submitAdd'.$this->table.'" class="button" />
			</div>
			<div class="small"><sup>*</sup> '.$this->l('Mandatory field').'</div>
		</form>';
		
		// TinyMCE include
		$pathCss = __PS_BASE_URI__.'modules/pss_newsletter/css/pss_styles_mce.css';
		echo '
			<!-- TinyMCE -->
			<script type="text/javascript" src="'.__PS_BASE_URI__.'modules/pss_timemsgpro/js/tiny_mce/tiny_mce.js"></script>
			<script type="text/javascript">
				tinyMCE.init({
					mode : "textareas",
					theme : "advanced",
					plugins : "safari,pagebreak,style,layer,table,advimage,advlink,inlinepopups,media,searchreplace,contextmenu,paste,directionality,fullscreen",
					// Theme options
					theme_advanced_buttons1 : "newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
					theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,,|,forecolor,backcolor",
					theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,media,|,ltr,rtl,|,fullscreen",
					theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,pagebreak",
					theme_advanced_toolbar_location : "top",
					theme_advanced_toolbar_align : "left",
					theme_advanced_statusbar_location : "bottom",
					theme_advanced_resizing : false,
					content_css : "'.__PS_BASE_URI__.'themes/'._THEME_NAME_.'/css/global.css",
					document_base_url : "'.__PS_BASE_URI__.'",
					width: "600",
					height: "auto",
					font_size_style_values : "8pt, 10pt, 12pt, 14pt, 18pt, 24pt, 36pt",
					// Drop lists for link/image/media/template dialogs
					template_external_list_url : "lists/template_list.js",
					external_link_list_url : "lists/link_list.js",
					external_image_list_url : "lists/image_list.js",
					media_external_list_url : "lists/media_list.js",
					elements : "nourlconvert",
					entity_encoding: "raw",
					convert_urls : false,
					language : "'.(file_exists(__PS_BASE_URI__.'modules/pss_timemsgpro/js/tinymce/jscripts/tiny_mce/langs/'.$iso.'.js') ? $iso : 'en').'"
				});
			</script>
			<!-- /TinyMCE -->';
	}
	/**
	 * Display a help area below the main list
	 */
	public function displayHelpArea()
	{
		global $currentIndex, $cookie;
		$iso = Language::getIsoById(intval($cookie->id_lang));	
		
		// Link to modules / position screen :
		// http://localhost/ps137/admin137/index.php?tab=AdminModulesPositions&token=...
		$positionUrl = PssTimeMsgProUtils::getAdminModulePositionUrl($currentIndex);
			
		echo '
		<h2 class="space">'.$this->l('User help').'</h2>
				<br />';
				
		// --------------------------------------------------------------------------
		// Hook module position link
		//
		echo '
			<div>
				'.$this->l('If you need to change the position of message display in a hook, please, follow the link below, find the group titled by the hook name and then use arrows to change display order.').'
				<br />
				<a href="'.$positionUrl.'" target="_blank" style="color:blue; text-decoration:underline;">'.$this->l('Click here to manage module positions').'</a>
				<br />
				<span style="text-size:11px; font-style:italic;">'.$this->l('To make it easier to find the module in lists, its description is grayed.').'</span>
			</div>
		';
		echo '
			<div class="clear">&nbsp;</div>';
			
		// --------------------------------------------------------------------------
		// Docs links
		//
		// load the list of PDF available in doc folder
		$docFolder = $this->absolutePath.'docs/';
		$docFiles = array();
		if (file_exists($docFolder) && $handle = opendir($docFolder)) {
			// some user friendly descriptions
			$docDescription = array(
				'01_pss_shopscheduler_free_edition_en' => array('lang'=>'en', 'label'=>$this->l('User Guide - Simple functions')),
				'01_pss_shopscheduler_free_edition_fr' => array('lang'=>'fr', 'label'=>$this->l('User Guide - Simple functions')),
				'02_pss_shopscheduler_pro_edition_en' => array('lang'=>'en', 'label'=>$this->l('Professional module documentation')),
				'02_pss_shopscheduler_pro_edition_fr' => array('lang'=>'fr', 'label'=>$this->l('Professional module documentation')),
				'03_pss_shopscheduler_how_to_copy_elements_en' => array('lang'=>'en', 'label'=>$this->l('Tutorial - How to copy elements from your theme ?')),
				'03_pss_shopscheduler_how_to_copy_elements_fr' => array('lang'=>'fr', 'label'=>$this->l('Tutorial - How to copy elements from your theme ?')),
				'04_pss_shopscheduler_tutorial_custom_class_and_template_en' => array('lang'=>'en', 'label'=>$this->l('Tutorial - How to create a custom action ?')),
				'04_pss_shopscheduler_tutorial_custom_class_and_template_fr' => array('lang'=>'fr', 'label'=>$this->l('Tutorial - How to create a custom action ?')),
				);
			// This is the correct way to loop over the directory
			while (false !== ($file = readdir($handle))) {
				$path_parts = pathinfo($file);
				$extension = $path_parts['extension'];
				if ($extension=='pdf') 
				{
					// if the doc is listed in the docDescription array ...
					if (array_key_exists($path_parts['filename'], $docDescription)) 
					{
						// ... display it only if its iso code match the cookie's one
						if ($docDescription[$path_parts['filename']]['lang']==$iso)
							$docFiles[$path_parts['filename']] = array(
								'link' => $this->absoluteUrl.'docs/'.$path_parts['basename'], 
								'description'=>$docDescription[$path_parts['filename']]['label']
							);
					}
					else	// always display custom docs
					{
						$docFiles[$path_parts['filename']] = array(
							'link' => $this->absoluteUrl.'docs/'.$path_parts['basename'], 
							'description'=>$path_parts['filename']
						);
					}
				}
			}
		}
		
		echo '
			<div>
				'.$this->l('Some docs are available in the module installation directory. Click on the links below to learn how to use the module functions.').'
		';
		if (!empty($docFiles))
		{
			echo '
				<ul class="bullet">';
			foreach ($docFiles as $doc_file=>$doc_infos)
			{
				echo '
					<li><a style="color:blue; text-decoration:underline;" href="'.$doc_infos['link'].'" target="_blank">'.$doc_infos['description'].'</a></li>
				';
			}
			echo '
				</ul>';
		}
		else
		{
			echo '<p style="font-weight:bold;">'.$this->l('No doc file found').'<p>';
		}
		echo '
			</div>
		';
	}
	/* *****************************************************************************************
	 *
	 *					INTERNAL TOOLS
	 *
	 * ***************************************************************************************** */
	/**
	 * List in the theme/modules/module/templates folder all .tpl files
	 */
	private function getTemplateList($includeTheme) 
	{
		$customTemplates = array();

		if ($includeTheme)
		{
			// theme template dir
			$themeModuleTemplateDir = _PS_THEME_DIR_.'modules/pss_timemsgpro/templates/';
			
			// check first if the folder exists
			if (file_exists($themeModuleTemplateDir) && $handle = opendir($themeModuleTemplateDir)) {
				// This is the correct way to loop over the directory
				while (false !== ($file = readdir($handle))) {
					$path_parts = pathinfo($file);
					$extension = $path_parts['extension'];
					if ($extension=='tpl')
					{	
						// store only the filename without extension
						$customTemplates[$path_parts['filename']] = $path_parts['filename'];
					}
				}
			}
		}

		// Union the basic module template list
		$standardTemplate = array(
							'template_empty'=>$this->l('Empty template'), 
							'template_std_content'=>$this->l('Standard content template'), 
							'template_std_column'=>$this->l('Standard column block template')
						);
		// merge standard template files and custom templates
		$templateList = array_merge($standardTemplate, $customTemplates);
		
		return $templateList;
	}
	/**
	 * Prepare the visible hook list available in current Prestashop version
	 */
	private function getVisibleHookList()
	{
		// Hook names have changed in PS 1.5
		// @change for Prestashop 1.5 compatibility
		if (PssTimeMsgProUtils::isPs15x())
		{
			$hookBasicList = array(
						'displayHome'=>$this->l('Home page : content'), 
						
						'displayRightColumn'=>$this->l('All pages : right column'), 
						'displayLeftColumn'=>$this->l('All pages : left column'), 
						'displayTop'=>$this->l('All pages : top'), 
						'displayFooter'=>$this->l('All pages : footer'), 

						'displayLeftColumnProduct'=>$this->l('Product pages : in the left column'),
						'displayRightColumnProduct'=>$this->l('Product pages : in the right column'),
						'displayProductButtons'=>$this->l('Product pages : in the buttons area'), 
						'displayProductTab'=>$this->l('Product pages : new Tab'), 
						'displayProductTabContent'=>$this->l('Product pages : new Tab content'), 
						'displayFooterProduct'=>$this->l('Product pages : under product description'), 

						'displayShoppingCart'=>$this->l('Cart page : above the addresses'), 
						'displayShoppingCartFooter'=>$this->l('Cart page : below the content'), 
						
						'displayPaymentTop'=>$this->l('Payment page : above the amount to pay'), 
						
						'displayMyAccountBlock'=>$this->l('Customer account : bottom of account block'),
						'displayMyAccountBlockfooter'=>$this->l('Customer account in footer : inside the account block'),
						'displayCustomerAccount'=>$this->l('Customer account : below page content'),
						'displayCustomerAccountFormTop'=>$this->l('Customer create account : above the form'),
						'displayCustomerAccountForm'=>$this->l('Customer create account : between the form fields and the create button'),
					);
		} 
		else
		{
			$hookBasicList = array(
						'home'=>$this->l('Home page : content'), 
						
						'rightColumn'=>$this->l('All pages : right column'), 
						'leftColumn'=>$this->l('All pages : left column'), 
						'top'=>$this->l('All pages : top'), 
						'footer'=>$this->l('All pages : footer'), 

						'extraLeft'=>$this->l('Product pages : in the left column'),
						'extraRight'=>$this->l('Product pages : in the right column'),
						'productActions'=>$this->l('Product pages : in the buttons area'), 
						'productTab'=>$this->l('Product pages : new Tab'), 
						'productTabContent'=>$this->l('Product pages : new Tab content'), 
						'productfooter'=>$this->l('Product pages : under product description'), 

						'shoppingCart'=>$this->l('Cart page : above the addresses'), 
						'shoppingCartExtra'=>$this->l('Cart page : below the content'), 
						
						'paymentTop'=>$this->l('Payment page : above the amount to pay'), 
						'paymentConfirm'=>$this->l('Payment confirmation page : above confirmation text'), 
						
						'myAccountBlock'=>$this->l('Customer account : bottom of account block'),
						'customerAccount'=>$this->l('Customer account : below page content'),
						'createAccountTop'=>$this->l('Customer create account : above the form'),
						'createAccountForm'=>$this->l('Customer create account : between the form fields and the create button'),
					);
		}
		$hookModuleList = array_keys($hookBasicList);
		// hookVersionList : the list of available hooks in running Prestashop version
		$versionHooks = Hook::getHooks();
		$hookVersionList = array();
		foreach ($versionHooks as $versionHook)
			$hookVersionList[] = $versionHook['name'];
		// hookAvailableList : the intersection	to keep only available hooks in this Prestashop version
		$hookAvailableList = array_intersect($hookModuleList, $hookVersionList);
		// hookList : final list = hook_name => hook_description
		$hookList = array();
		foreach ($hookAvailableList as $hookAvailable)
		{
			$hookList[$hookAvailable] = $hookBasicList[$hookAvailable];
		}
		// TODO : to improve the hook list display
/*		$hookList = array(
						'000-0'=>$this->l-NOT('------- Choose one -------'), 
						'000-1'=>$this->l-NOT(''), 
						'000-2'=>$this->l-NOT('********* Home page'), 
						'home'=>$this->l-NOT('content'), 
						
						'000-10'=>$this->l-NOT(''), 
						'000-11'=>$this->l-NOT('********* All pages'), 
						'rightColumn'=>$this->l-NOT('right column'), 
						'leftColumn'=>$this->l-NOT('left column'), 
						'top'=>$this->l-NOT('top'), 
						'footer'=>$this->l-NOT('footer'), 
						
						'000-20'=>$this->l-NOT(''), 
						'000-21'=>$this->l-NOT('********* Product pages'), 
						'extraLeft'=>$this->l-NOT('in the left column'),
						'extraRight'=>$this->l-NOT('in the right column'),
						'productActions'=>$this->l-NOT('in the buttons area'), 
						'productTab'=>$this->l-NOT('new Tab'), 
						'productTabContent'=>$this->l-NOT('new Tab content'), 
						'productfooter'=>$this->l-NOT('under product description'), 
					);*/
		return $hookList;
	}
	
	/* *****************************************************************************************
	 *
	 *					DEAL WITH VERSION MIGRATION
	 *
	 * ***************************************************************************************** */
	/**
	 * Display the form to inform user that the module has to be updated
	 */
	private function displayMigrationForm($installedVersion) 
	{
		global $cookie;

		// display errors if any
		if (!empty($this->_errors))
		{
			foreach ($this->_errors as $error)
				$this->_html .= '<div class="alert error">'.$error.'</div>';
		}
		
		$this->_html .= '
		<form action="'.Tools::htmlentitiesUTF8($_SERVER['REQUEST_URI']).'" method="post" enctype="multipart/form-data" class="width2" style="width:100%;">
			<fieldset><legend><img src="../img/admin/nav-user.gif" />'.$this->l('Module update').'</legend>
				<div style="text-align:center; color:red; font-size:15px; font-weight:bold;">'.$this->l('Important').' !!</div>
				<div style="height:20px;">&nbsp;</div>
				<div style="text-align:center;">'.$this->l('Your module directory contains a newer version. It must be applied before going on.').'</div>
				<div style="height:10px;">&nbsp;</div>
				<div style="text-align:center;">'.$this->l('Installed version').' : '.$installedVersion.' / '.$this->l('Directory version').' : '.$this->_directoryVersion.'</div>
				<div style="height:40px;">&nbsp;</div>
				<div style="text-align:center;">
					<input type="submit" value="'.$this->l('   Update   ').'" name="submitUpdateModule" class="button" />
				</div>
			</fieldset>
		</form>';
		return $this->_html;
	}
	/**
	 * Manage datas migration for an already installed version
	 * Check for each version of version history. Start migrating after currently installed version,
	 * and stop migrating after target version achieved.
	 * Returns true if the migration is ok or false elsewhere
	 */
	private function migrateVersion($installedVersion)
	{
		// if module not installed, return
		if (!$installedVersion)
			return;

		// if the version is up-to-date, return
		if ($installedVersion===$this->_directoryVersion)
			return;
			
		// look for installed version in the history
		$migrate = false;
		foreach($this->_versionHistory as $v)
		{
			// apply migrate
			if ($migrate)
			{
				$migrationFunction = 'migrate_to_'.str_replace ('.', '_', $v);
				if ($this->$migrationFunction())
					Configuration::updateValue('PRESTASCOPE_TIMEMSG_VERSION',  $v);
				else	// some issue during migration, so interrupt the migration
					return false;					
			}
			// start to migrate after installed version
			if ($v === $installedVersion) 
				$migrate = true;
			// stop to migrate after target version
			if ($v === $this->_directoryVersion) 
				$migrate = false;
		}

		return true;
	}
	private function migrate_to_0_2() 
	{
		PssTimeMsgProUtils::addLog("Migration to 0.2 starts ...");
		
		// add two new fields to prestascope_timemsgpro table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `id_category` INT( 10 ) NOT NULL default \'0\' AFTER `id_group`';
		Db::getInstance()->Execute($query);
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `id_product` INT( 10 ) NOT NULL default \'0\' AFTER `id_category`';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 0.2 ends with success");
		return true;
	}
	private function migrate_to_0_3() 
	{
		PssTimeMsgProUtils::addLog("Migration to 0.3 starts ...");
		
		// add one new field to prestascope_timemsgpro table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `other_rule` varchar(255) AFTER `id_product`';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 0.3 ends with success");
		return true;
	}
	private function migrate_to_0_4() 
	{
		PssTimeMsgProUtils::addLog("Migration to 0.4 starts ...");
		
		// add one new field to prestascope_timemsgpro table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `cron_expression` varchar(25) AFTER `to_date`';
		Db::getInstance()->Execute($query);
		// delete one unused field to prestascope_timemsgpro_lang table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro_lang` DROP `href`';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 0.4 ends with success");
		return true;
	}
	private function migrate_to_0_5() 
	{
		PssTimeMsgProUtils::addLog("Migration to 0.5 starts ...");
		
		// add one new field to prestascope_timemsgpro table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `duration` int(10) AFTER `cron_expression`';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 0.5 ends with success");
		return true;
	}
	private function migrate_to_0_6() 
	{
		PssTimeMsgProUtils::addLog("Migration to 0.6 starts ...");
		
		// add one new field to prestascope_timemsgpro table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `is_logged` tinyint(1) NOT NULL DEFAULT 0 AFTER `id_product`';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 0.6 ends with success");
		return true;
	}
	private function migrate_to_1_0() 
	{
		PssTimeMsgProUtils::addLog("Migration to 1.0 starts ...");
		
		// add one new field to prestascope_timemsgpro table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `user_class` varchar(128) AFTER `template_name`';
		Db::getInstance()->Execute($query);
		// remove the NOT NULL constraint on this field
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro_lang` MODIFY `msg` text';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 1.0 ends with success");
		return true;
	}
	private function migrate_to_1_1() 
	{
		PssTimeMsgProUtils::addLog("Migration to 1.1 starts ...");
		
		// add one new field to prestascope_timemsgpro table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `exceptions` varchar(255) AFTER `other_rule`';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 1.1 ends with success");
		return true;
	}
	private function migrate_to_1_2() 
	{
		PssTimeMsgProUtils::addLog("Migration to 1.2 starts ...");
		
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `is_message` tinyint(1) NOT NULL DEFAULT \'0\' AFTER `hook_name`';
		Db::getInstance()->Execute($query);
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` MODIFY `id_group` int(10)';
		Db::getInstance()->Execute($query);
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` MODIFY `id_category` int(10)';
		Db::getInstance()->Execute($query);
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` MODIFY `id_product` int(10)';
		Db::getInstance()->Execute($query);
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` MODIFY `is_logged` tinyint(1)';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 1.2 ends with success");
		return true;
	}
	private function migrate_to_1_3() 
	{
		PssTimeMsgProUtils::addLog("Migration to 1.3 starts ...");
		
		// add one new field to prestascope_timemsgpro table
		$query = 'ALTER TABLE `' . _DB_PREFIX_ . 'prestascope_timemsgpro` ADD `css_name` varchar(255) NOT NULL AFTER `template_name`';
		Db::getInstance()->Execute($query);
		
		PssTimeMsgProUtils::addLog("Migration to 1.3 ends with success");
		return true;
	}
	private function migrate_to_1_4() 
	{
		PssTimeMsgProUtils::addLog("Migration to 1.4 starts ...");
		PssTimeMsgProUtils::addLog("Migration to 1.4 ends with success");
		return true;
	}
	private function migrate_to_1_5() 
	{
		PssTimeMsgProUtils::addLog("Migration to 1.5 starts ...");
		PssTimeMsgProUtils::addLog("Migration to 1.5 ends with success");
		return true;
	}
}
?>
